#include <iostream>
#include <Gosu/Gosu.hpp>
#include <string>
#include <sstream>

using namespace std;

/**
 * @brief Clase Completado
 * 
 *@author Ezequiel
*/
class Completado{
public:
  /**Constructor de Completado*/
  Completado(Gosu::Graphics & graphics){ 
    imagen_= new Gosu::Image(graphics, L"../Imagenes/completo.png");
    texto_= new Gosu::Font(graphics,L"../Imagenes/letra.ttf",32,Gosu::ffBold);
  }
  
  /**Funcion que se encarga de dibujar la puntuacion cuando se ha completado un nivel*/
  void draw(int puntuacion,  float puntuacion_total){
    imagen_->draw(200,225,0);
    
    texto_->draw(L"NIVEL COMPLETADO:",290,253,1,1,1,Gosu::Color::WHITE);
    wstringstream wss;
    wss << puntuacion << " %";
    wstring ws = wss.str();
    //string num = puntuacion;
    texto_->draw(ws,380,280,1,1,1,Gosu::Color::WHITE);
    
    texto_->draw(L"PUNTUACION TOTAL : ",290,340,1,1,1,Gosu::Color::WHITE);
    float aux = (puntuacion_total/12);
    wstringstream wss2;
    wss2 << aux << " %";
    ws = wss2.str();
    texto_->draw(ws,380,370,1,1,1,Gosu::Color::WHITE);
  }

  /**Funcion que se encarga del manejo de botones cuando se ha completado un nivel*/
  void buttonDown(Gosu::Button B,int & menu_,int & completo_){

    if(B== Gosu::msLeft){
      menu_ = 1;
      completo_ = 0;				
    }
  }	

private:
  Gosu::Image * imagen_;
  Gosu::Font *  texto_;

};

