#ifndef _MENU_
#define _MENU_

#include <Gosu/Gosu.hpp>
#include "sonido.h"
#include <fstream>

/**
 * @brief Clase Menu
 * 
 *@author Lucia
*/
class Menu{
private:
  Gosu::Image * bellota_nivel; //bellota_nivel
  Gosu::Image * valla_menu; //valla_menu
  Gosu::Image * bellota_bloqueada; //bellota bloqueada  
  Gosu::Font * numero;
  Gosu::Font * texto;
  Sonido& sonmenu_;
  
public:
  /**Constructor de Menu*/
  Menu(Gosu::Graphics & graphics,Sonido & sonido):sonmenu_(sonido){
    bellota_nivel = new Gosu::Image(graphics, L"../Imagenes/Bellota.png");	
    bellota_bloqueada = new Gosu::Image(graphics, L"../Imagenes/bloqueado.png");
    valla_menu= new Gosu::Image(graphics,L"../Imagenes/valla_menu.png");
    numero= new Gosu::Font(graphics, L"../Imagenes/letra.ttf",80,0);
    texto = new Gosu::Font(graphics,L"../Imagenes/letra.ttf",30,0);
    
  }
  
  /**Destructor Menu*/
  ~Menu(){
    delete bellota_nivel;
    delete bellota_bloqueada;
    delete valla_menu;
    delete numero;
    delete texto;    
  }
  
  /**Funcion que se encarga de dibujar el escenario de niveles
    *@param int  
    */ 
  void draw(int bloqueado_){
    if(bloqueado_ >= 1)
      bellota_nivel-> draw(20, 200, 1); //dibujamos la bellota del primer nivel
    else
      bellota_bloqueada-> draw(20, 200, 1); //dibujamos la bellota del primer nivel
    numero->draw(L"1",40, 205, 1); //dibujamos el numero del nivel

    if(bloqueado_ >= 2)
      bellota_nivel-> draw(130, 200, 1);
    else
      bellota_bloqueada-> draw(130, 200, 1);
    numero->draw(L"2",150, 205, 1);
    
    if(bloqueado_ >= 3)
      bellota_nivel-> draw(240, 200, 1);
    else
      bellota_bloqueada->draw(240, 200, 1);
    numero->draw(L"3",260, 205, 1);

    if (bloqueado_ >= 4)
      bellota_nivel-> draw(350, 200, 1);
    else
      bellota_bloqueada-> draw(350, 200, 1);
    numero->draw(L"4",370, 205, 1);

    //Dibujamos las bellotas de la segunda fila
    if (bloqueado_ >= 5)
      bellota_nivel-> draw(20, 300, 1);	
    else
      bellota_bloqueada-> draw(20, 300, 1);
    numero->draw(L"5",40, 305, 1);

    if(bloqueado_ >= 6)
      bellota_nivel-> draw(130, 300, 1);
    else
      bellota_bloqueada-> draw(130, 300, 1);
    numero->draw(L"6",150, 305, 1);

    if(bloqueado_ >= 7)
      bellota_nivel-> draw(240, 300, 1);
    else
      bellota_bloqueada->draw(240, 300, 1);
    numero->draw(L"7",260, 305, 1);	

    if(bloqueado_ >= 8)
      bellota_nivel->draw(350, 300, 1);
    else
      bellota_bloqueada->draw(350, 300, 1);
    numero->draw(L"8",370, 305, 1);	
    
    //Dibujamos las bellotas de la tercera fila
    if(bloqueado_ >= 9)
      bellota_nivel-> draw(20, 400, 1);
    else
      bellota_bloqueada->draw(20, 400, 1);
    numero->draw(L"9",40, 405, 1);
    
    if(bloqueado_ >= 10)
      bellota_nivel-> draw(130, 400, 1);
    else
      bellota_bloqueada->draw(130, 400, 1);
    numero->draw(L"10",140, 405, 1);

    if(bloqueado_ >= 11)
      bellota_nivel-> draw(240, 400, 1);
    else
      bellota_bloqueada->draw(240, 400, 1);
    numero->draw(L"11",250, 405, 1);	
    
    if(bloqueado_ >= 12)
      bellota_nivel-> draw(350, 400, 1);
    else
      bellota_bloqueada-> draw(350, 400, 1);
    numero->draw(L"12",360, 405, 1);   
    
    valla_menu-> draw(550,275, 1);  
    texto->draw(L"Menu",630, 355, 1);  
    texto->draw(L"Pausar musica",590, 410, 1); 
    texto->draw(L"Creditos",619,384, 1); 
  }

  /**Funcion que se encarga del manejo de botones en el menu de niveles
    *@param Gosu::Button &, Gosu::Input &, string &, int &, int &, int &,int &  
    */ 
  void buttonDown(Gosu::Button & B, Gosu::Input & input, string & nivel_, int & principal_, int & menu_,
    int & creditos, int & guardado_){
    
    if(B== Gosu::msLeft){
      //tomamos las coordenadas del cursor
      int mX=input.mouseX();
      int mY=input.mouseY();

      if(mY > 200 && mY < 300){ //Si pulsamos en la primera fila de bellotas
	if(mX > 20 && mX < 120 && guardado_>=1) //si pulsamos en la primera columna 
	{
	  nivel_ = "1";
	  if(!sonmenu_.silencio())
	    sonmenu_.cambiarnivel();
	}//seleccionamos el nivel 1.
	else if (mX > 130 && mX < 210 && guardado_>=2) //si pulsamos en la segunda columna
	{
	  nivel_ = "2";
	  if(!sonmenu_.silencio())
	    sonmenu_.cambiarnivel();
	}
	else if (mX > 240 && mX < 320 && guardado_>=3) //si pulsamos en la tercera columna
	{
	  nivel_ = "3";
	  if(!sonmenu_.silencio())
	    sonmenu_.cambiarnivel();
	} 
	else if (mX > 350 && mX < 430 && guardado_>=4){ //si pulsamos en la cuarta columna
	  nivel_ = "4";
	  if(!sonmenu_.silencio())
	    sonmenu_.cambiarnivel();
	}
      }
      else if (mY > 300 && mY < 400){ //Segunda fila
	if(mX > 20 && mX < 120 && guardado_>=5){
	  nivel_ = "5";
	  if(!sonmenu_.silencio())
	    sonmenu_.cambiarnivel();
	}
	else if (mX > 130 && mX < 210 && guardado_>=6){
	  nivel_ = "6";
	  if(!sonmenu_.silencio())
	    sonmenu_.cambiarnivel();
	}
	else if (mX > 240 && mX < 320 && guardado_>=7){
	  nivel_ = "7";
	  if(!sonmenu_.silencio())
	    sonmenu_.cambiarnivel();
	}
	else if (mX > 350 && mX < 430 && guardado_>=8){
	  nivel_ = "8";
	  if(!sonmenu_.silencio())
	    sonmenu_.cambiarnivel();
	}
      }
      else if (mY > 400 && mY < 500){ //Tercera fila
	if(mX > 20 && mX < 120 && guardado_>=9){
	  nivel_ = "9";
	  if(!sonmenu_.silencio())
	    sonmenu_.cambiarnivel();
	}
	else if (mX > 130 && mX < 210 && guardado_>=10){
	  nivel_ = "10";
	  if(!sonmenu_.silencio())
	    sonmenu_.cambiarnivel();	
	}
	else if (mX > 240 && mX < 320 && guardado_>=11){
	  nivel_ = "11";
	  if(!sonmenu_.silencio())
	    sonmenu_.cambiarnivel();	
	}
	else if (mX > 350 && mX < 430 && guardado_>=12){
	  nivel_ = "12";
	  if(!sonmenu_.silencio())
	    sonmenu_.cambiarnivel();		
	}	
      }
      
      if((mX > 576 && mX < 748) && (mY > 358 && mY < 383))
      {
	principal_ =1;  //ponemos el menu principal a 1 porque es la primera ventana que se muestra
	nivel_ ="0"; //ponemos el menu a o porque inicialemente no queremos tener ningun nivel visible
	menu_=0; 
	if(!sonmenu_.silencio())
	  sonmenu_.cambiarfondo();
      }
    
      if((mX > 549 && mX < 742) && (mY > 417 && mY < 444))
      {
	sonmenu_.silenciar();
      }

      if((mX > 583 && mX < 742) && (mY >388 && mY < 409))
      {		
	creditos=1;
	principal_=0;
	nivel_="0";
	menu_=0;
      }
    }
  }
};
#endif


