#include <Gosu/Gosu.hpp>

#ifndef SONIDO_H_
#define SONIDO_H_

/**
 * @brief Clase Sonido
 * 
 *@author Ezequiel
*/

class Sonido{
public:
  /**Constructor de Sonido */
  Sonido(){
    songFondo=new Gosu::Song(L"../sonido/musica1.ogg");	
    songNivel=new Gosu::Song(L"../sonido/musica2.ogg");
    songFondo-> play(true);
    cancion_ = 0;
  };
  
  /**Silencia la musica que esté sonando*/
  void silenciar(){  
    if(silencio_==false){
      silencio_=true;
      if (cancion_==0)
	songFondo->stop();
      else 
	songNivel->stop();
    }
    else{
      silencio_=false;
      if(cancion_ == 0)
	songFondo->play();
      else
	songNivel->play();
    }
  };
 
  /** { Observadoras de sonido*/
  Gosu::Song *  sonidofondo(){return songFondo;};
  Gosu::Song * sonidoNivel(){return songNivel;};
  /** @ } */
  
  /** {Devuelve el estado del silencio*/
  bool  silencio()const{return silencio_;};
  bool&  silencio(){return silencio_;};
  /** @ } */
   
  /**Si no esta pausada la musica cambia la musica del nivel por la musica de fondo*/
  void cambiarfondo(){
    cancion_=0;
    if(!silencio())
    {
      songFondo->play();
      songNivel->stop();
    } 
   };
   
  /**Si no esta pausada la musica cambia la musica de fondo por la musica de nivel*/ 
  void cambiarnivel(){
    cancion_=1;
    if(!silencio()){
      songFondo->stop();
      songNivel->play();
    } 
    
    
   };
  
   /**Destructor de Sonido*/
  ~Sonido(){
     //delete songFondo;
     //delete songNivel;
  }
  
private:
  bool silencio_;
  int cancion_; //0 si fondo y 1 si nivel
  Gosu::Song * songFondo;
  Gosu::Song * songNivel;

};


#endif
