#include <iostream>
#include <fstream>
#include <stdlib.h>
#include "tablero.h"


using namespace std;

tablero::tablero(string nombre):nombre_(nombre){ //lee el fichero y lo almacena en el tablero y bellotas
  ifstream fichero;
  string ruta="../Niveles/";
  fichero.open ((ruta+nombre).c_str(), ios::in); //se lee el fichero del nivel correspondiente
  
  nivel = atoi(nombre.c_str());
  
  for(int i = 0; i < 12; i++){  
    for(int j = 0; j < 12; j++){  //se va rellenando el tablero con los numeros del fichero
      fichero >> tablero_[i][j];
      bellotas_[i][j] = 0;
      if(tablero_[i][j] == bellota){ //si es una bellota 
      	bellotas_[i][j] = 1; //en el tablero de bellotas colocamos esa bellota
	tablero_[i][j] = 0; //ponemos esa casilla como libre en el tablero
      }
    }  
  }
  fichero >> pasos_; //numero de paso minimos 
  pasos_andados = 0;
  puntuacion_ = 0;
  fichero.close(); //cerramos fichero
}

bool tablero::comprobar(){ //comprueba si se ha ganado o no
  bool gana = true;

  for(int k = 0; k < 12; k++){
    for(int l = 0; l < 12; l++){
      if(tablero_[k][l]==cerdo) //si hay un cerdo que no está en una bellota 
	if(bellotas_[k][l] != 1) 
	  gana = false;  //Aun no se ha ganado
    }  
  }
  
  puntuacion_ = ((float)(pasos_/pasos_andados))*100;
  return gana; //devolvemos si se ha ganado o no
}

void tablero::buscar_granjero(int &i, int &j){ //busca el granjero en el tablero y devuelve su posicion
  for(int k = 0; k < 12; k++){
    for(int l = 0; l < 12; l++){
      if(tablero_[k][l]==granjero){ //recoremos todo el tablero buscando el granjero
        i = k;
        j = l;
      }
    }  
   }
}

bool tablero::movimiento_valido(int x,int y){
	int i,j;
	buscar_granjero(i,j);
	if(tablero_[i+x][j+y]==cerdo)
		return (i+(2*x) > 0 && j+(2*y) > 0 && tablero_[i+(2*x)][j+(2*y)]!= invalida && tablero_[i+(2*x)][j+(2*y)]!= valla_tras && tablero_[i+(2*x)][j+(2*y)]!= valla_del && tablero_[i+(2*x)][j+(2*y)]!= valla_izq && tablero_[i+(2*x)][j+(2*y)]!= valla_der && tablero_[i+(2*x)][j+(2*y)]!= tras_izq && tablero_[i+(2*x)][j+(2*y)]!= tras_der && tablero_[i+(2*x)][j+(2*y)]!=del_izq && tablero_[i+(2*x)][j+(2*y)]!= del_der && tablero_[i+(2*x)][j+(2*y)]!= cerdo); 	//mirar cuando el granjero este al lado del cerdo y el cerdo pegado a las vallas o a otro cerdo.
	else	
		return (i+x > 0 && j+y > 0 && tablero_[i+x][j+y]!= invalida && tablero_[i+x][j+y]!= valla_tras && tablero_[i+x][j+y]!= valla_del && tablero_[i+x][j+y]!= valla_izq && tablero_[i+x][j+y]!= valla_der && tablero_[i+x][j+y]!= tras_izq && tablero_[i+x][j+y]!= tras_der && tablero_[i+x][j+y]!=del_izq && tablero_[i+x][j+y]!= del_der);
	
} 

bool tablero::mover(int x, int y){ //devuelve verdadero si mueve al cerdo y falso si no..
  int i,j;
  buscar_granjero(i,j);
  if (movimiento_valido(x,y)){
    ++ pasos_andados; //aumento el numero de pasos andados
    if(tablero_[i+x][j+y] == libre){
      swap(tablero_[i][j], tablero_[i+x][j+y]);

      return false; //no mueve al cerdo
    }
    else if (tablero_[i+x][j+y] == cerdo){
      tablero_[i][j]=libre;
      tablero_[i+x][j+y]=granjero;
      tablero_[i+(x*2)][j+(y*2)]=cerdo; 
      return true; //mueve al cerdo
      
    }
  }
  else
    return false;
  //imprimir();
}

void tablero::restaurar(){
  ifstream fichero;
	string ruta="../Niveles/";
  fichero.open ((ruta+nombre_).c_str(), ios::in);
  
	for(int i = 0; i < 12; i++){
    for(int j = 0; j < 12; j++){
      fichero >> tablero_[i][j];
      bellotas_[i][j] = 0;
      if(tablero_[i][j] == bellota){
      	bellotas_[i][j] = 1;
	tablero_[i][j] = 0;
      }
    }  
  }
  fichero.close();  
  pasos_andados = 0;	
}

/*
void tablero::imprimir(){
  system("clear");
  cout << " X: mover abajo, S: mover arriba, Z: mover izquierda, C: mover derecha," << endl;
  cout << "                    R: restaurar, Q: salir " << endl;
  cout << "-----------------------------------------------------------------------" << endl << endl;
  for(int i = 0; i < 12; i++){
    for(int j = 0; j < 12; j++){
      cout << tablero_[i][j] << " " ;
    }
		cout << "             "; 
		for(int j = 0; j < 12; j++){
      cout << bellotas_[i][j] << " " ;
    }
    cout << endl;
  }
  cout << endl;
}
*/

